;; From http://www.emacswiki.org/cgi-bin/wiki/JumpToPrevPos
(defvar jtpp-pos-stack nil
  "Stack of previous positions.")

(defvar jtpp-stack-depth 16
  "*Stack depth for jump-to-prev-pos.")

(defconst jtpp-running-xemacs (featurep 'xemacs)
  "Are we running XEmacs?")

(defun jtpp-in-minibuffer ()
  (if jtpp-running-xemacs
      (minibuffer-window-active-p (selected-window))
    (minibufferp)))

(defun jtpp-remember-position ()
  ;; TODO Save buffer too?
  (unless (or (equal (point) (car jtpp-pos-stack))
              (equal last-command 'jump-to-prev-pos)
              (jtpp-in-minibuffer))
    (setq jtpp-pos-stack (cons (point) jtpp-pos-stack))
    (when (> (length jtpp-pos-stack) jtpp-stack-depth)
      (nbutlast jtpp-pos-stack))))
(add-hook 'pre-command-hook 'jtpp-remember-position)

(defun jump-to-prev-pos ()
  "Jump to previous position."
  (interactive)
  (when (equal (point) (car jtpp-pos-stack))
    (setq jtpp-pos-stack (cdr jtpp-pos-stack)))
  (when jtpp-pos-stack
    (goto-char (car jtpp-pos-stack))
    (setq jtpp-pos-stack (cdr jtpp-pos-stack))))

(provide 'jumptoprevpos)